-- spooky forest

add_choice_text("Arboreal Respite", { -- choice adventure number: 502
	["Follow the old road"] = "Go to The Road Less Traveled (buy spooky sapling)",
	["Explore the stream"] = "Go to Consciousness of a Stream (get larva or tree-holed coin)",
	["Brave the dark thicket"] = "Go to Through Thicket and Thinnet (get spooky temple map, fertilizer or starting items)",
})

add_choice_text("Consciousness of a Stream", { -- choice adventure number: 505
	["March to the marsh"] = "Get mosquito larva or 3 spooky mushrooms",
	["Squeeze into the cave"] = "Get tree-holed coin and gain 300 meat (first time only)",
	["Go further upstream"] = "Go to An Interesting Choice (meet a vampire)",
})

add_choice_text("The Road Less Traveled", { -- choice adventure number: 503
	["Follow the ruts"] = "Gain some meat",
	["Knock on the cottage door"] = "Get wooden stakes or trade vampire hearts",
	["Talk to the hunter"] = { text = "Buy spooky saplings and sell bar skins", good_choice = true },
})

add_choice_text("Through Thicket and Thinnet", { -- choice adventure number: 506
	["Follow the even darker path"] = "Get starting items",
	["Investigate the dense foliage"] = { getitem = "Spooky-Gro fertilizer" },
	["Follow the coin"] = { getitem = "spooky temple map" },
})

add_choice_text("O Lith, Mon", { -- choice adventure number: 507
	["Insert coin to continue"] = { getitem = "spooky temple map", good_choice = true },
	["Ignore the monolith"] = { disabled = true, leave_noturn = true },
	["Hit a monkey with a bone"] = { disabled = true, leave_noturn = true },
})


-- old spooky forest
add_choice_text("An Interesting Choice", { -- choice adventure number: 46
	["Interview the vampire"] = "Gain 5-10 moxie",
	["Interrogate the vampire"] = "Gain 5-10 muscle",
	["Inter the vampire"] = "<b>Fight a spooky vampire</b>",
})

add_choice_text("A Three-Tined Fork", { -- choice adventure number: 26
	["Take the normal path"] = "Get muscle class items, e.g. turtle totem",
	["Take the scorched path"] = "Get mysticality class items, e.g. saucepan + spices",
	["Take the dark path"] = "Get moxie class items, e.g. stolen accordion",
})

add_choice_text("Footprints", { -- choice adventure number: 27
	["Follow the single set to the copse"] = { getitem = { "seal-clubbing club", "seal-skull helmet" } },
	["Follow the double set to the other copse"] = { getitem = { "helmet turtle", "turtle totem" }, good_choice = true },
})

add_choice_text("A Pair of Craters", { -- choice adventure number: 28
	["Investigate the smoking crater"] = { getitem = { "pasta spoon", "ravioli hat" } },
	["Investigate the moist crater"] = { getitem = { "saucepan", "spices" }, good_choice = true },
})

add_choice_text("The Road Less Visible", { -- choice adventure number: 29
	["Continue down the path"] = { getitem = { "disco mask", "disco ball" } },
	["Investigate the bushes"] = { getitem = { "stolen accordion", "mariachi pants" }, good_choice = true },
})

-- friars

add_printer("item drop", function ()
	if string.match(text, "hellion cube") then
		count = tonumber(count_inventory_item("hellion cube"))
		if count == 1 then
			text = "<center>" .. text .. "<br>(" .. count .. " hellion cube in inventory.)</center>"
		else
			text = "<center>" .. text .. "<br>(" .. count .. " hellion cubes in inventory.)</center>"
		end
	end
end)

add_choice_function("Bureaucracy of the Damned", function()
	items = {
		"Azazel's unicorn",
		"Azazel's lollipop",
		"Azazel's tutu",
	}
	num_items = 0
	for a,b in pairs(items) do
		num_items = num_items + tonumber(count_inventory_item(b)) -- /count works in-choice
--~ 		print("azazel items", b, num_items)
	end
	if num_items == 3 then
		return { -- choice adventure number: 161
			["Follow the pencilnecked demon"] = { text = "Get steel organ" },
			["Follow the pencilnecked demon"] = { text = "Get steel organ" },
			["Follow, follow, follow, follow, follow the pencilnecked demon"] = { text = "Get steel organ" },
			["Don't follow the pencilnecked demon"] = { disabled = true },
		}
	else
		return { -- choice adventure number: 161
			["Follow the pencilnecked demon"] = { text = tostring(num_items) .. " / 3 items for steel organ", disabled = true },
			["Follow the pencilnecked demon"] = { text = tostring(num_items) .. " / 3 items for steel organ", disabled = true },
			["Follow, follow, follow, follow, follow the pencilnecked demon"] = { text = tostring(num_items) .. " / 3 items for steel organ", disabled = true },
			["Don't follow the pencilnecked demon"] = { leave_noturn = true },
		}
	end
end)


-- Whitey's Grove

add_choice_text("Don't Fence Me In", {
	["Whitewash the fence"] = "Gain 20-30 muscle",
	["Steal the fence"] = "Get a white picket fence",
	["Jump the fence"] = "Get a piece of wedding cake + white rice [max 3 per day, or 5 with a rice bowl]",
})

add_choice_text("Rapido!", {
	["Steer for the cave"] = "Gain 20-30 mysticality",
	["Steer for the trees"] = "Get 3 jars of white lightning",
	["Steer for the laundromat"] = "Get a white collar",
})

add_choice_text("The Only Thing About Him is the Way That He Walks", {
	["Show him some moves"] = "Gain 20-30 moxie",
	["Show him a good time"] = "Get 3 boxes of wine",
	["Show him how easy it is to steal all of his stuff"] = "Get mullet wig",
})

add_printer("item drop", function ()
	if text:contains(" pixel") then
		local white = tonumber(count_inventory_item("white pixel")) -- /count is slow, but works in combat
		local red = tonumber(count_inventory_item("red pixel"))
		local green = tonumber(count_inventory_item("green pixel"))
		local blue = tonumber(count_inventory_item("blue pixel"))
		local count = white + math.min(red, green, blue)
		text = "<center>" .. text .. "<br>(" .. count .. " of 30 white pixels found.)</center>"
	end
end)

add_automator("/mystic.php", function ()
	if text:contains("Would you like to hear a tale") then
		post_page("/mystic.php", { action = "crackyes1" })
		post_page("/mystic.php", { action = "crackyes2" })
		text = post_page("/mystic.php", { action = "crackyes3" })
	end
end)
